

#define MOUSEPAR_COLOR 2
#define NUMINPUT_COLOR 12

#include <vgagl.h>
#include <vgamouse.h>

#include "globdef.h"
#include "uidef.h"
#include "screendef.h"


void erase_numinput_txt(void)
{
int i;
numinput_txt[0]='_';
for(i=1; i<numinput_chars; i++)numinput_txt[i]=' ';
numinput_txt[numinput_chars]=0;
settextcolor(15);
errno=20115;
ck_write(numinput_xpix,numinput_ypix,numinput_txt);  
numinput_curpos=0;
}

void do_nothing(void)
{
}

void get_numinput_chars(void)
{
int i, flag;
flag=0;
if(vga_inkey == 10 || vga_inkey == 13)
  {
  hide_mouse();
  switch (numinput_flag)
    {
    case FIXED_INT_PARM:
    sscanf(numinput_txt,"%d",&numinput_int_data);
    break;

    case FIXED_FLOAT_PARM:
    sscanf(numinput_txt,"%f",&numinput_float_data);
    break;
    }
  par_from_keyboard_routine();
  show_mouse();
  mouse_active_flag=0;
  numinput_flag=0;
  vga_inkey=0;
  leftpressed=0;  
  return;
  } 
if(vga_inkey == 8 || vga_inkey == 127 || vga_inkey == ARROW_LEFT_KEY)
  {
  if(numinput_curpos==0)return;
  numinput_curpos--;
  numinput_txt[numinput_curpos]='_';
  numinput_txt[numinput_curpos+1]=' ';
  hide_mouse();  
errno=20116;
  ck_write(numinput_xpix,numinput_ypix,numinput_txt);  
  show_mouse();
  return;
  }
if( (vga_inkey >= '0' && vga_inkey <= '9') || numinput_flag == TEXT_PARM)
  {
  flag=1;
  }
if(numinput_curpos == 0 && vga_inkey == '-' && numinput_flag != TEXT_PARM)
  {
  flag=1;
  }
if( numinput_flag == FIXED_FLOAT_PARM)
  {
  if(vga_inkey == '.' || vga_inkey == 'E')
    {
    for(i=0; i<numinput_curpos; i++)if(numinput_txt[i] == vga_inkey)return;
    flag=1;
    }
  if(numinput_curpos > 0 && vga_inkey == '-')
    {
    if(numinput_txt[numinput_curpos-1] == 'E')
      {
      flag=1;
      }
    }
  }
if(flag == 1)
  {
  numinput_txt[numinput_curpos]=vga_inkey;
  numinput_curpos++;
  }
if(numinput_curpos > numinput_chars-1)
  {
  numinput_curpos=numinput_chars-1;
  }
else
  {  
  numinput_txt[numinput_curpos]='_';
  }
numinput_txt[numinput_curpos+1]=0;
hide_mouse();  
errno=20117;
ck_write(numinput_xpix,numinput_ypix,numinput_txt);  
show_mouse();
}

void show_mouse(void)
{
int i,imax;
unsigned char color;
if(mouse_hide_flag == 1)return;
mouse_hide_flag=1;
color=15-2*leftpressed-5*rightpressed;
imax=WIDTH-mouse_x;
if(imax > mouse_cursize) imax=mouse_cursize;
for(i=1; i<imax; i++)
  {
  behind_mouse[4*i  ]=gl_getpixel(mouse_x+i,mouse_y);
errno=10534;
  ck_setpixel(mouse_x+i,mouse_y,color);
  }
imax=mouse_x;
if(imax > mouse_cursize) imax=mouse_cursize;
for(i=1; i<imax; i++)
  {
  behind_mouse[4*i+1]=gl_getpixel(mouse_x-i,mouse_y);
errno=10535;
  ck_setpixel(mouse_x-i,mouse_y,color);
  }
imax=HEIGHT-mouse_y;
if(imax > mouse_cursize) imax=mouse_cursize;
for(i=1; i<imax; i++)
  {
  behind_mouse[4*i+2]=gl_getpixel(mouse_x,mouse_y+i);
errno=10536;
  ck_setpixel(mouse_x,mouse_y+i,color);
  }
imax=mouse_y;
if(imax > mouse_cursize) imax=mouse_cursize;
for(i=1; i<imax; i++)
  {
  behind_mouse[4*i+3]=gl_getpixel(mouse_x,mouse_y-i);
errno=10537;
  ck_setpixel(mouse_x,mouse_y-i,color);
  }
behind_mouse[0]=gl_getpixel(mouse_x,mouse_y);
errno=10538;
ck_setpixel(mouse_x,mouse_y,color);
}


void hide_mouse(void)
{
int i,imax;
if(mouse_hide_flag ==0)return;
mouse_hide_flag=0;
imax=WIDTH-mouse_x;
if(imax > mouse_cursize) imax=mouse_cursize;
for(i=1; i<imax; i++)
  {
errno=10539;
  ck_setpixel(mouse_x+i,mouse_y,behind_mouse[4*i  ]);
  }
imax=mouse_x;
if(imax > mouse_cursize) imax=mouse_cursize;
for(i=1; i<imax; i++)
  {
errno=10540;
  ck_setpixel(mouse_x-i,mouse_y,behind_mouse[4*i+1]);
  }
imax=HEIGHT-mouse_y;
if(imax > mouse_cursize) imax=mouse_cursize;
for(i=1; i<imax; i++)
  {
errno=10541;
  ck_setpixel(mouse_x,mouse_y+i,behind_mouse[4*i+2]);
  }
imax=mouse_y;
if(imax > mouse_cursize) imax=mouse_cursize;
for(i=1; i<imax; i++)
  {
errno=10542;
  ck_setpixel(mouse_x,mouse_y-i,behind_mouse[4*i+3]);
  }
errno=10543;
ck_setpixel(mouse_x,mouse_y,behind_mouse[0]);
}

void dsp_mouse(void)
{
int x, y, button;
mouse_update();
x = mouse_getx();
y = mouse_gety();
button = mouse_getbutton();
if (button & MOUSE_LEFTBUTTON) 
  {
  if (leftpressed==0)
    {
    leftpressed = 1;
    }
  }
else
  {
  if(leftpressed==1)
    {
    leftpressed = 2;
    }
  }
if (button & MOUSE_RIGHTBUTTON) 
  {
  if (rightpressed==0)
    {
    rightpressed = 1;
    }
  }
else
  {
  if(rightpressed==1)
    {
    rightpressed = 2;
    }
  }
if( x==mouse_x && y==mouse_y)return;
hide_mouse();
mouse_x=x;
mouse_y=y;
show_mouse();
}

void open_mouse(void)
{
if(mouse_flag != 0)end_program(1003);
mouse_cursize=HEIGHT/80;
behind_mouse = chk_malloc(4*(mouse_cursize+1)*sizeof(char),1033);
mouse_setxrange(0, WIDTH-1);
mouse_setyrange(0, HEIGHT-1);
mouse_setwrap(MOUSE_NOWRAP);
mouse_setscale(ui.mouse_speed);
mouse_x=WIDTH/2;
mouse_y=HEIGHT/2;
mouse_setposition( mouse_x, mouse_y);
mouse_hide_flag=0;
show_mouse();
leftpressed=0;
rightpressed=0;
mouse_flag=1;
mouse_active_flag=0;
}

void close_mouse(void)
{
if(mouse_flag == 0)end_program(1004);
free(behind_mouse);
mouse_flag=0;
}
