
#include "globdef.h"
#include "uidef.h"
#include "conf.h"



ROUTINE par_from_keyboard_routine;

int fft2_to_fft1_ratio;
float baseband_bw_hz;
int baseband_bw_fftxpts;
audio_buf_info da_info;
int mouse_flag;
int graphics_flag;
int vga_inkey;
char *vga_font;
int text_width;
int text_height;
int text_midpoint;
USERINT_PARM ui;
int mouse_hide_flag;
int mouse_x;
int mouse_y;
int mouse_cursize;
char *behind_mouse;
int leftpressed;
int rightpressed;
int mmx_present;
int simd_present;
int audio_in;
int audio_in2;
int audio_out;
int mixer; 
int rx_channels;
int twice_rxchan;
FILE *dmp;
FILE *wav_file;
int adout_block;
char *da_wrbuf;
float total_wttim;
int da_output_bytes;
int da_output_channels;
int timinfo_flag;
int ampinfo_flag;
float measured_da_speed;
float measured_ad_speed;
int rx_mode;
int use_bfo;
int newdat_flag;
int fullbuf_flag;
double workload_start_time;
double info_time;
double bg_maxamp_time;
double workload_max_latency;
double latest_idle_time;
double idle_start;
double workload_idle;
float workload_total;
float workload_percentage;
double sound_start_time;
double recent_time;
double diskread_time;
double eme_time;
int dasync_counter;
float dasync_sum;
float dasync_avg1;
float dasync_avg2;
float dasync_avg3;
double dasync_time;
double dasync_avgtime;
double daspeed_time;
double da_start_time;
double disksync_time;
int overrun_count;
int overrun_flag;
int dasync_errors;
int da_start_bytes;
int wav_write_flag;
int wav_read_flag;
int wavfile_bytes;
int audio_dump_flag;
int current_graph_minh;
int current_graph_minw;
int calibrate_flag;
int network_flag;
int flowinfo_flag;
struct sockaddr_in network_address;
int network_sockfd;
int network_fd;
int network_modeno;
double old_passband_center;
int swmmx_fft1;
int swmmx_fft2;
int sw_onechan;
int memalloc_no;
int memalloc_max;
MEM_INF *memalloc_mem;
int eme_flag;
int idle_flag;
int timf3_oscilloscope_limit;
int lir_status;
int allow_parport;

DXDATA *dx;
MEM_INF fft1mem[MAX_FFT1_ARRAYS];
MEM_INF fft3mem[MAX_FFT3_ARRAYS];
MEM_INF basebmem[MAX_BASEB_ARRAYS];
MEM_INF hiresmem[MAX_HIRES_ARRAYS];
MEM_INF afcmem[MAX_AFC_ARRAYS];
int cwlong_no_of_traces[CWLONG_MAXBUF];
double flowcnt[MAX_FLOWCNT];
double flowtime;
int mailbox[64];



char savefile_parname[44];  //40chars +  _ag  + ending zero.




char userint_filename[]="par_userint";
char *rxpar_filenames[MAX_RX_MODE]={"par_wcw",
                         "par_cw",
                         "par_hsms",
                         "par_ssb",
                         "par_fm",
                         "par_am",
                         "par_qrss",
                         "par_txtest",
                         "par_test",
                         "par_tune"};

char *rxmodes[MAX_RX_MODE]={"Weak signal CW",
                 "Normal CW",
                 "Meteor scatter CW",
                 "SSB",
                 "FM",
                 "AM",
                 "QRSS CW",
                 "TX TEST",
                 "SOUNDCARD TEST MODE",
                 "ANALOG HARDWARE TUNE"};

#define A MAX_MIX1
#define B MAX_FFT1_VERNR
#define C MAX_FFT1_BCKVERNR
#define D 1000
#define E 1000000
#define F 10000
#define G MAX_FFT2_VERNR
#define H 200
#define K 6000
#define M 8000
#define A1 100
#define B5 5000
int genparm[MAX_GENPARM+2];
//                           1 1  1  1 1   1   1 1 1 1  2 2  2 2 2 2 2 2
//    0 1 2  3 4 5 6 7  8  9 0 1  2  3 4   5   6 7 8 9  0 1  2 3 4 5 6 7
int genparm_min[MAX_GENPARM]=
   {  0,0,0, 0,1,0,0,H, 2, 0,0,0, 2, 0,0,  1, 0,0,0,1, 1,1, 9,0,H,0,0};
int genparm_max[MAX_GENPARM]=
   {800,9,B,60,E,1,C,E,99,10,4,G,16,99,1,500,B5,1,E,H,10,A, D,H,E,H,9};
int genparm_default[MAX_RX_MODE][MAX_GENPARM]=
// Weak signal CW
   {100,3,2, 4,D,1,0,K, 6, 2,1,0, 8,20,0,150,A1,0,0,5, 4,1, H,5,K,1,3,
// Normal CW
    100,3,2, 1,D,0,0,K, 6, 2,0,0, 7, 5,0,150,A1,0,0,5, 4,1,20,5,M,1,3,
// Meteor scatter CW
    100,2,2, 1,D,1,0,K, 6, 2,0,0, 7, 5,1,150,A1,0,0,5, 4,1, H,5,F,1,3,
// SSB
     83,2,0, 1,D,1,0,K, 6, 2,0,0, 7, 5,1,150,A1,0,0,5, 4,1, H,5,F,1,3,
// FM
     84,2,0, 1,D,1,0,K, 6, 2,0,0, 7, 5,1,150,A1,0,0,5, 4,1, H,5,F,1,3,
// AM
    100,3,2, 1,D,0,0,K, 6, 2,0,0, 7, 5,0,150,A1,0,0,5, 4,1,20,5,M,1,3,
// QRSS CW
    100,2,2, 1,D,1,0,K, 6, 2,0,0, 7, 5,1,150,A1,0,0,5, 4,1, H,5,F,1,3,
// Tx test
     83,2,0, 1,D,1,0,K, 6, 2,0,0, 7, 5,1,150,A1,0,0,5, 4,1, H,5,F,1,3,
// Soundcard test
     83,2,0, 1,D,1,0,K, 6, 2,0,0, 7, 5,1,150,A1,0,0,5, 4,1, H,5,F,1,3,
// Analog hardware tune
     85,2,0, 1,D,1,0,K, 6, 2,0,0, 7, 5,1,150,A1,0,0,5, 4,1, H,5,F,1,3};


char *genparm_text[MAX_GENPARM+2]={"First FFT bandwidth (Hz)",          //0
                      "First FFT window (power of sin)",                //1
                      "First forward FFT version",                      //2  
                      "First FFT storage time (s)",                     //3 
                      "First FFT amplitude",                            //4
                      "Enable second FFT",                              //5
                      "First backward FFT version",                     //6
                      "Sellim maxlevel",                                //7 
                      "First backward FFT att. N",                      //8 
                      "Second FFT bandwidth factor in powers of 2",     //9
                      "Second FFT window (power of sin)",               //10
                      "Second forward FFT version",                     //11
                      "Second forward FFT att. N",                      //12 
                      "Second FFT storage time (s)",                    //13
                      "Enable AFC/SPUR/DECODE",                         //14
                      "AFC lock range Hz",                              //15
                      "AFC max drift Hz/minute",                        //16
                      "Enable Morse decoding",                          //17
                      "Max no of spurs to cancel",                      //18
                      "Spur timeconstant (0.1sek)",                     //19
                      "First mixer bandwidth reduction in powers of 2", //20
                      "First mixer no of channels",                     //21
                      "Baseband storage time (s)",                      //22 
                      "Output delay margin (0.1sek)",                   //23   
                      "Output sampling speed (Hz)",                     //24
                      "Default output mode",                            //25
                      "Audio expander exponent",                        //26 
                      "A/D speed",                                      //27
                      "Check"}; 

char *uiparm_text[MAX_UIPARM]={"vga mode",         //1
                               "font scale",       //2
                               "mouse speed",      //3
                               "input mode",       //4
                               "rx channels",      //5
                               "ad channels",      //6
                               "ad speed",         //7
                               "ad device no",     //8
                               "ad device mode",   //9
                               "ad frag",          //10 
                               "da device no",     //11
                               "min da speed",     //12  
                               "max da speed",     //13
                               "max da channels",  //14
                               "max da bytes",     //15
                               "min da channels",  //16
                               "min da bytes",     //17
                               "da stop/start",    //18 
                               "memlock",          //19
                               "usleep",           //20
                               "check"};           //21


char *ag_intpar_text[MAX_AG_INTPAR]={"ytop",               //1
                                     "ybottom",            //2
                                     "xleft",              //3
                                     "xright",             //4
                                     "mode",               //5
                                     "avgnum",             //6
                                     "window",             //7 
                                     "fit points",         //8
                                     "delay",              //9
                                     "check"};             //10

char *ag_floatpar_text[MAX_AG_FLOATPAR]={"min S/N",        //1
                                         "search range",   //2
                                         "lock_range",     //3
                                         "freq range"};    //4    




char *wg_intpar_text[MAX_WG_INTPAR]={"ytop",               //1
                                     "ybottom",            //2
                                     "xleft",              //3
                                     "xright",             //4
                                     "yborder",            //5
                                     "xpoints per pixel",  //6
                                     "pixels per xpoint",  //7
                                     "first xpoint",       //8
                                     "xpoints",            //9
                                     "avg1num",            //10 
                                     "spek avgnum",        //11  
                                     "waterfall avgnum",   //12
                                     "check"};             //13               

char *wg_floatpar_text[MAX_WG_FLOATPAR]={"yzero",          //1
                                         "yrange",         //2 
                                         "wat. db zero",   //3
                                         "wat. db gain"};  //4

char *hg_intpar_text[MAX_HG_INTPAR]={"ytop",                //1
                                     "ybottom",             //2
                                     "xleft",               //3
                                     "xright",              //4
                                     "mode (dumb)",         //5
                                     "mode (clever)",       //6
                                     "timf2 display",       //7 
                                     "timf2 display lines", //8
                                     "timf2 display hold",  //9
                                     "spek avgnum",         //10
                                     "limit (dumb)",        //11
                                     "limit (clever)",      //12
                                     "check"};              //13

char *hg_floatpar_text[MAX_HG_FLOATPAR]={"factor (dumb)",          //1
                                         "factor (clever)",        //2
                                         "sellim fft1 S/N",        //3
                                         "sellim fft2 S/N",        //4    
                                         "timf2 display gain wk",  //5 
                                         "timf2 display gain st"}; //6 

char *bg_intpar_text[MAX_BG_INTPAR]={"ytop",                //1
                                     "ybottom",             //2
                                     "xleft",               //3
                                     "xright",              //4
                                     "yborder",             //5
                                     "fft3 avgnum",         //6
                                     "pixels/point",        //7
                                     "coh factor",          //8 
                                     "delay points",        //9
                                     "AGC flag",            //10
                                     "AGC attack",          //11
                                     "AGC release",         //12
                                     "Waterfall avgnum",    //13
                                     "AFC2 range",          //14
                                     "AFC2 delay",          //15
                                     "check"};              //16

char *bg_floatpar_text[MAX_BG_FLOATPAR]={"filter flat",          //1
                                         "filter curved",        //2
                                         "yzero",                //3
                                         "yrange",               //4    
                                         "dB/pixel",             //5 
                                         "yfac pwr",             //6
                                         "yfac log",             //7
                                         "bandwidth",            //8
                                         "first freq",           //9
                                         "BFO freq",             //10
                                         "Output gain",          //11
                                         "Waterfall gain",       //12
                                         "Waterfall zero"};      //13


char *pg_intpar_text[MAX_PG_INTPAR]={"ytop",            //1
                                     "ybottom",         //2
                                     "xleft",           //3
                                     "xright",          //4
                                     "adapt",           //5
                                     "avg",             //6
                                     "check"};          //7

char *pg_floatpar_text[MAX_PG_FLOATPAR]={"angle",     //1
                                         "c1",        //2
                                         "c2",        //3
                                         "c3"};       //4    



char *cg_intpar_text[MAX_CG_INTPAR]={"ytop",            //1
                                     "ybottom",         //2
                                     "xleft",           //3
                                     "xright"};          //4

char *cg_floatpar_text[MAX_CG_FLOATPAR];


char *eg_intpar_text[MAX_EG_INTPAR]={"ytop",            //1
                                     "ybottom",         //2
                                     "xleft",           //3
                                     "xright",          //4
                                     "minim"};          //5

char *eg_floatpar_text[MAX_EG_FLOATPAR];


char *fg_intpar_text[MAX_FG_INTPAR]={"ytop",            //1
                                     "ybottom",         //2
                                     "xleft",           //3
                                     "xright",          //4
                                     "direction",       //5
                                     "gain",            //6
                                     "gain_inc"};       //7

char *fg_floatpar_text[MAX_FG_FLOATPAR]={"fq_inc",      //1
                                          "freq"};      //2


char modes_man_auto[]={'-','A','M'};
char *press_any_key={"Press any key"};

