
#include "globdef.h"
#include "uidef.h"
#include "fft1def.h"

void fft1_approx_dit_one(void)
{
int p0;
int m;
int ia, ib, ic, id;
int ja, jb, jc, jd;
int j,nn;
float t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12;
float *x;
float a1,a2;
float b1,b2;
float c1,c2;
float d1,d2;
x=&fft1_float[fft1_pa];
m=ctimf1_mask;
p0=(ctimf1p_px/sizeof(int)-fft1_interleave_points*2*ui.rx_channels+
                                                           ctimf1_bytes)&m;
nn=fft1_size;
if(genparm[FIRST_FFT_SINPOW] == 0)
  {
  for(j=0; j<nn; j+=4)
    {
    ia=(p0+2*fft1_permute[j  ])&m;
    ib=(p0+2*fft1_permute[j+1])&m;
    ic=(p0+2*fft1_permute[j+2])&m;
    id=(p0+2*fft1_permute[j+3])&m;

    t1=ctimf1[ia  ]+ctimf1[ib  ];
    t2=ctimf1[ia+1]+ctimf1[ib+1];

    t3=ctimf1[ic  ]+ctimf1[id  ];
    t4=ctimf1[ic+1]+ctimf1[id+1];
  
    t5=ctimf1[ia  ]-ctimf1[ib  ];
    t7=ctimf1[ia+1]-ctimf1[ib+1];
  
    t10=ctimf1[ic  ]-ctimf1[id  ];
    t6= ctimf1[ic+1]-ctimf1[id+1];
  
    x[2*j  ]=t1+t3;
    x[2*j+1]=t2+t4;
  
    x[2*j+4]=t1-t3;
    x[2*j+5]=t2-t4;
  
    t11=t5-t6;
    t8=t7-t10;
    
    t12=t5+t6;
    t9=t7+t10;
  
    x[2*j+2]=t12;
    x[2*j+3]=t8;
  
    x[2*j+6]=t11;
    x[2*j+7]=t9;
    }
  }
else 
  {
// clearly an error here !!!!!!!! (???? aug 2003 )
  for(j=0; j<nn; j+=4)
    {
    ja=fft1_permute[j  ];
    jb=fft1_permute[j+1];
    jc=fft1_permute[j+2];
    jd=fft1_permute[j+3];

    ia=(p0+2*ja)&m;
    ib=(p0+2*jb)&m;
    ic=(p0+2*jc)&m;
    id=(p0+2*jd)&m;
    a1=fft1_window[ja]*ctimf1[ia  ];
    a2=fft1_window[ja]*ctimf1[ia+1];

    b1=fft1_window[jb]*ctimf1[ib  ];
    b2=fft1_window[jb]*ctimf1[ib+1];

    c1=fft1_window[jc]*ctimf1[ic  ];
    c2=fft1_window[jc]*ctimf1[ic+1];

    d1=fft1_window[jd]*ctimf1[id  ];
    d2=fft1_window[jd]*ctimf1[id+1];
    t1=a1+b1;
    t2=a2+b2;
  
    t3=c1+d1;
    t4=c2+d2;
  
    t5=a1-b1;
    t7=a2-b2;
  
    t10=c1-d1;
    t6= c2-d2;

    x[2*j  ]=t1+t3;
    x[2*j+1]=t2+t4;
  
    x[2*j+4]=t1-t3;
    x[2*j+5]=t2-t4;
  
    t11=t5-t6;
    t8=t7-t10;
    
    t12=t5+t6;
    t9=t7+t10;
  
    x[2*j+2]=t12;
    x[2*j+3]=t8;
  
    x[2*j+6]=t11;
    x[2*j+7]=t9;
    }
  }
bulk_of_dit(fft1_size, fft1_n, x, fft1tab);
}

void fft1_approx_dit_two(void)
{
int p0;
int chan, m;
int ia, ib, ic, id;
int ja, jb, jc, jd;
int i,j,k,nn;
float t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12;
float r1,r2,r3,r4,r5,r6,r7,r8,r9,r10,r11,r12;
float *x;
float a1,a2,a3,a4;
float b1,b2,b3,b4;
float c1,c2,c3,c4;
float d1,d2,d3,d4;
x=&fft1_float[fft1_pa];
m=ctimf1_mask;
p0=(ctimf1p_px/sizeof(int)-fft1_interleave_points*2*ui.rx_channels+
                                                           ctimf1_bytes)&m;
nn=fft1_size;

if(FFT1_CURMODE == 3)
  {
  if(genparm[FIRST_FFT_SINPOW] == 0)
    {
    for(j=0; j<nn; j+=4)
      {
      ia=(p0+4*fft1_permute[j  ])&m;
      ib=(p0+4*fft1_permute[j+1])&m;
      ic=(p0+4*fft1_permute[j+2])&m;
      id=(p0+4*fft1_permute[j+3])&m;
  
      t1=ctimf1[ia  ]+ctimf1[ib  ];
      t2=ctimf1[ia+1]+ctimf1[ib+1];
      r1=ctimf1[ia+2]+ctimf1[ib+2];
      r2=ctimf1[ia+3]+ctimf1[ib+3];
  
      t3=ctimf1[ic  ]+ctimf1[id  ];
      t4=ctimf1[ic+1]+ctimf1[id+1];
      r3=ctimf1[ic+2]+ctimf1[id+2];
      r4=ctimf1[ic+3]+ctimf1[id+3];
  
      t5=ctimf1[ia  ]-ctimf1[ib  ];
      t7=ctimf1[ia+1]-ctimf1[ib+1];
      r5=ctimf1[ia+2]-ctimf1[ib+2];
      r7=ctimf1[ia+3]-ctimf1[ib+3];
  
      t10=ctimf1[ic  ]-ctimf1[id  ];
      t6= ctimf1[ic+1]-ctimf1[id+1];
      r10=ctimf1[ic+2]-ctimf1[id+2];  
      r6= ctimf1[ic+3]-ctimf1[id+3];
  
      x[4*j  ]=t1+t3;
      x[4*j+1]=t2+t4;
      x[4*j+2]=r1+r3;
      x[4*j+3]=r2+r4;
  
      x[4*j+8]=t1-t3;
      x[4*j+9]=t2-t4;
      x[4*j+10]=r1-r3;
      x[4*j+11]=r2-r4;
  
      t11=t5-t6;
      t8=t7-t10;
      r11=r5-r6;
      r8=r7-r10;
    
      t12=t5+t6;
      t9=t7+t10;
      r12=r5+r6;
      r9=r7+r10;
  
      x[4*j+4]=t12;
      x[4*j+5]=t8;
      x[4*j+6]=r12;
      x[4*j+7]=r8;
  
      x[4*j+12]=t11;
      x[4*j+13]=t9;
      x[4*j+14]=r11;
      x[4*j+15]=r9;
      }
    }
  else 
    {
    for(j=0; j<nn; j+=4)
      {
      ja=fft1_permute[j  ];
      jb=fft1_permute[j+1];
      jc=fft1_permute[j+2];
      jd=fft1_permute[j+3];

      ia=(p0+4*ja)&m;
      ib=(p0+4*jb)&m;
      ic=(p0+4*jc)&m;
      id=(p0+4*jd)&m;

      a1=fft1_window[ja]*ctimf1[ia  ];
      a2=fft1_window[ja]*ctimf1[ia+1];
      a3=fft1_window[ja]*ctimf1[ia+2];
      a4=fft1_window[ja]*ctimf1[ia+3];

      b1=fft1_window[jb]*ctimf1[ib  ];
      b2=fft1_window[jb]*ctimf1[ib+1];
      b3=fft1_window[jb]*ctimf1[ib+2];
      b4=fft1_window[jb]*ctimf1[ib+3];

      c1=fft1_window[jc]*ctimf1[ic  ];
      c2=fft1_window[jc]*ctimf1[ic+1];
      c3=fft1_window[jc]*ctimf1[ic+2];
      c4=fft1_window[jc]*ctimf1[ic+3];

      d1=fft1_window[jd]*ctimf1[id  ];
      d2=fft1_window[jd]*ctimf1[id+1];
      d3=fft1_window[jd]*ctimf1[id+2];
      d4=fft1_window[jd]*ctimf1[id+3];

      t1=a1+b1;
      t2=a2+b2;
      r1=a3+b3;
      r2=a4+b4;
  
      t3=c1+d1;
      t4=c2+d2;
      r3=c3+d3;
      r4=c4+d4;
  
      t5=a1-b1;
      t7=a2-b2;
      r5=a3-b3;
      r7=a4-b4;
  
      t10=c1-d1;
      t6= c2-d2;
      r10=c3-d3;
      r6= c4-d4;

      x[4*j  ]=t1+t3;
      x[4*j+1]=t2+t4;
      x[4*j+2]=r1+r3;
      x[4*j+3]=r2+r4;
  
      x[4*j+8]=t1-t3;
      x[4*j+9]=t2-t4;
      x[4*j+10]=r1-r3;
      x[4*j+11]=r2-r4;
  
      t11=t5-t6;
      t8=t7-t10;
      r11=r5-r6;
      r8=r7-r10;
    
      t12=t5+t6;
      t9=t7+t10;
      r12=r5+r6;
      r9=r7+r10;
  
      x[4*j+4]=t12;
      x[4*j+5]=t8;
      x[4*j+6]=r12;
      x[4*j+7]=r8;
  
      x[4*j+12]=t11;
      x[4*j+13]=t9;
      x[4*j+14]=r11;
      x[4*j+15]=r9;
      }
    }
  bulk_of_dual_dit(fft1_size, fft1_n, x, fft1tab);
  }
else
  {
  for(chan=0; chan<2; chan++)
    {
    if(genparm[FIRST_FFT_SINPOW] == 0)
      {
      for(j=0; j<nn; j+=4)
        {
        ia=(p0+4*fft1_permute[j  ]+2*chan)&m;
        ib=(p0+4*fft1_permute[j+1]+2*chan)&m;
        ic=(p0+4*fft1_permute[j+2]+2*chan)&m;
        id=(p0+4*fft1_permute[j+3]+2*chan)&m;
  
        t1=ctimf1[ia  ]+ctimf1[ib  ];
        t2=ctimf1[ia+1]+ctimf1[ib+1];
  
        t3=ctimf1[ic  ]+ctimf1[id  ];
        t4=ctimf1[ic+1]+ctimf1[id+1];
  
        t5=ctimf1[ia  ]-ctimf1[ib  ];
        t7=ctimf1[ia+1]-ctimf1[ib+1];
  
        t10=ctimf1[ic  ]-ctimf1[id  ];
        t6= ctimf1[ic+1]-ctimf1[id+1];
  
        fft1_tmp[2*j  ]=t1+t3;
        fft1_tmp[2*j+1]=t2+t4;
  
        fft1_tmp[2*j+4]=t1-t3;
        fft1_tmp[2*j+5]=t2-t4;
  
        t11=t5-t6;
        t8=t7-t10;
    
        t12=t5+t6;
        t9=t7+t10;
  
        fft1_tmp[2*j+2]=t12;
        fft1_tmp[2*j+3]=t8;
  
        fft1_tmp[2*j+6]=t11;
        fft1_tmp[2*j+7]=t9;
        }
      }
    else 
      {
      for(j=0; j<nn; j+=4)
        {
        ja=fft1_permute[j  ];
        jb=fft1_permute[j+1];
        jc=fft1_permute[j+2];
        jd=fft1_permute[j+3];

        ia=(p0+4*ja+2*chan)&m;
        ib=(p0+4*jb+2*chan)&m;
        ic=(p0+4*jc+2*chan)&m;
        id=(p0+4*jd+2*chan)&m;

        a1=fft1_window[ja]*ctimf1[ia  ];
        a2=fft1_window[ja]*ctimf1[ia+1];

        b1=fft1_window[jb]*ctimf1[ib  ];
        b2=fft1_window[jb]*ctimf1[ib+1];

        c1=fft1_window[jc]*ctimf1[ic  ];
        c2=fft1_window[jc]*ctimf1[ic+1];

        d1=fft1_window[jd]*ctimf1[id  ];
        d2=fft1_window[jd]*ctimf1[id+1];

        t1=a1+b1;
        t2=a2+b2;
  
        t3=c1+d1;
        t4=c2+d2;
  
        t5=a1-b1;
        t7=a2-b2;
  
        t10=c1-d1;
        t6= c2-d2;
  
        fft1_tmp[2*j  ]=t1+t3;
        fft1_tmp[2*j+1]=t2+t4;
  
        fft1_tmp[2*j+4]=t1-t3;
        fft1_tmp[2*j+5]=t2-t4;
  
        t11=t5-t6;
        t8=t7-t10;
    
        t12=t5+t6;
        t9=t7+t10;
  
        fft1_tmp[2*j+2]=t12;
        fft1_tmp[2*j+3]=t8;
  
        fft1_tmp[2*j+6]=t11;
        fft1_tmp[2*j+7]=t9;
        }
      }
    bulk_of_dit(fft1_size, fft1_n, fft1_tmp, fft1tab);
    k=2*chan;
    nn=2*fft1_size;
    for(i=0; i<nn; i+=2)
      {
      x[2*i+k  ]=fft1_tmp[i];
      x[2*i+k+1]=fft1_tmp[i+1];  
      }
    }  
  }
}


void fft1_approx_dif_one(void)
{
int p0,pa,pb,pc;
int ia,ib,ic;
int m,n;
register float t1,t2,t3,t4;
register float x1,x2;
m=ctimf1_mask;
p0=(ctimf1p_px/sizeof(int)-fft1_interleave_points*2*ui.rx_channels+
                                                           ctimf1_bytes)&m;
pa=p0;
pb=(p0+fft1_size)&m;
ib=fft1_size-2;
n=fft1_size/2;
if(genparm[FIRST_FFT_SINPOW] == 0)
  {
  for( ia=0; ia<n; ia++)
    {
    ib+=2;
    t1=ctimf1[pa  ];
    t2=ctimf1[pa+1];      
    t3=ctimf1[pb  ];
    t4=ctimf1[pb+1];   
    x1=t1-t3;
    fft1_tmp[2*ia  ]=  t1+t3;
    x2=t4-t2;
    fft1_tmp[2*ia+1]=-(t2+t4);
    pa=(pa+2)&m;
    pb=(pb+2)&m;
    fft1_tmp[ib  ]=fft1tab[ia].cos*x1-fft1tab[ia].sin*x2;
    fft1_tmp[ib+1]=fft1tab[ia].sin*x1+fft1tab[ia].cos*x2;
    }
  }
else 
  {
  for( ia=0; ia<n; ia++)
    {
    ib+=2;
    t1=ctimf1[pa  ]*fft1_window[2*ia];
    t2=ctimf1[pa+1]*fft1_window[2*ia];      
    t3=ctimf1[pb  ]*fft1_window[2*ia+1];
    t4=ctimf1[pb+1]*fft1_window[2*ia+1];   
    x1=t1-t3;
    fft1_tmp[2*ia  ]=  t1+t3;
    x2=t4-t2;
    fft1_tmp[2*ia+1]=-(t2+t4);
    pa=(pa+2)&m;
    pb=(pb+2)&m;
    fft1_tmp[ib  ]=fft1tab[ia].cos*x1-fft1tab[ia].sin*x2;
    fft1_tmp[ib+1]=fft1tab[ia].sin*x1+fft1tab[ia].cos*x2;
    }
  }
if(FFT1_CURMODE == 0)
  {
  bulk_of_dif(fft1_size, fft1_n, fft1_tmp, fft1tab);
  }
else
  {
  asmbulk_of_dif(fft1_size, fft1_n, fft1_tmp, fft1tab);
  }
pc=fft1_pa/2;
n=fft1_size;
for(ia=0; ia < n; ia+=2)
  {
  ib=pc+fft1_permute[ia  ];                               
  ic=pc+fft1_permute[ia+1];
  fft1_float[2*ib  ]=fft1_tmp[2*ia  ]+fft1_tmp[2*ia+2];
  fft1_float[2*ic  ]=fft1_tmp[2*ia  ]-fft1_tmp[2*ia+2];
  fft1_float[2*ib+1]=fft1_tmp[2*ia+1]+fft1_tmp[2*ia+3];
  fft1_float[2*ic+1]=fft1_tmp[2*ia+1]-fft1_tmp[2*ia+3];
  }
}

void fft1_approx_dif_two(void)
{
int p0,pa,pb,pc;
int ia,ib,ic;
int m,n,nn,chan;
register float t1,t2,t3,t4;
register float x1,x2;
register float x3,x4,r1,r2,r3,r4;
m=ctimf1_mask;
n=fft1_size/2;
nn=fft1_size;
p0=(ctimf1p_px/sizeof(int)-fft1_interleave_points*2*ui.rx_channels+
                                                           ctimf1_bytes)&m;


if(FFT1_CURMODE == 0)
  {
  for(chan=0; chan<2; chan++)
    {
    ib=fft1_size-2;
    pa=(p0+2*chan)&m;
    pb=(pa+2*fft1_size)&m;
    if(genparm[FIRST_FFT_SINPOW] != 0) 
      {

      for( ia=0; ia<n; ia++)
        {
        ib+=2;
        t1=ctimf1[pa  ]*fft1_window[2*ia];
        t2=ctimf1[pa+1]*fft1_window[2*ia];      
        t3=ctimf1[pb  ]*fft1_window[2*ia+1];
        t4=ctimf1[pb+1]*fft1_window[2*ia+1];   
        x1=t1-t3;
        x2=t4-t2;
        fft1_tmp[2*ia  ]=  t1+t3;
        fft1_tmp[2*ia+1]=-(t2+t4);
        pa=(pa+4)&m;
        pb=(pb+4)&m;
        fft1_tmp[ib  ]=fft1tab[ia].cos*x1-fft1tab[ia].sin*x2;
        fft1_tmp[ib+1]=fft1tab[ia].sin*x1+fft1tab[ia].cos*x2;
        }
      }
    else   
      {
      for( ia=0; ia<n; ia++)
        {
        ib+=2;
        t1=ctimf1[pa  ];
        t2=ctimf1[pa+1];      
        t3=ctimf1[pb  ];
        t4=ctimf1[pb+1];   
        x1=t1-t3;
        x2=t4-t2;
        fft1_tmp[2*ia  ]=  t1+t3;
        fft1_tmp[2*ia+1]=-(t2+t4);
        pa=(pa+4)&m;
        pb=(pb+4)&m;
        fft1_tmp[ib  ]=fft1tab[ia].cos*x1-fft1tab[ia].sin*x2;
        fft1_tmp[ib+1]=fft1tab[ia].sin*x1+fft1tab[ia].cos*x2;
        }
      }
    bulk_of_dif(fft1_size, fft1_n, fft1_tmp, fft1tab);
    pc=2*(chan+fft1_pa/2);
    for(ia=0; ia < nn; ia+=2)
      {
      ib=pc+4*fft1_permute[ia];                               
      ic=pc+4*fft1_permute[ia+1];                             
      fft1_float[ib  ]=fft1_tmp[2*ia  ]+fft1_tmp[2*ia+2];
      fft1_float[ic  ]=fft1_tmp[2*ia  ]-fft1_tmp[2*ia+2];
      fft1_float[ib+1]=fft1_tmp[2*ia+1]+fft1_tmp[2*ia+3];
      fft1_float[ic+1]=fft1_tmp[2*ia+1]-fft1_tmp[2*ia+3];
      }
    }
  }
else    
  {
  pa=p0;
  pb=(p0+2*fft1_size)&m;
  ib=2*fft1_size-4;
  if(genparm[FIRST_FFT_SINPOW] != 0)
    {
    for( ia=0; ia<n; ia++)
      {
      t1=ctimf1[pa  ]*fft1_window[2*ia];
      ib+=4;
      t2=ctimf1[pa+1]*fft1_window[2*ia];      
      t3=ctimf1[pb  ]*fft1_window[2*ia+1];
      t4=ctimf1[pb+1]*fft1_window[2*ia+1];   
      x1=t1-t3;
      fft1_tmp[4*ia  ]=  t1+t3;
      x2=t4-t2;
      fft1_tmp[4*ia+1]=-(t2+t4);
      r1=ctimf1[pa+2]*fft1_window[2*ia];
      r2=ctimf1[pa+3]*fft1_window[2*ia];      
      r3=ctimf1[pb+2]*fft1_window[2*ia+1];
      r4=ctimf1[pb+3]*fft1_window[2*ia+1];   
      x3=r1-r3;
      x4=r4-r2;
      fft1_tmp[4*ia+2]=  r1+r3;
      fft1_tmp[4*ia+3]=-(r2+r4);
      fft1_tmp[ib  ]=fft1tab[ia].cos*x1-fft1tab[ia].sin*x2;
      fft1_tmp[ib+1]=fft1tab[ia].sin*x1+fft1tab[ia].cos*x2;
      fft1_tmp[ib+2]=fft1tab[ia].cos*x3-fft1tab[ia].sin*x4;
      fft1_tmp[ib+3]=fft1tab[ia].sin*x3+fft1tab[ia].cos*x4;
      pa=(pa+4)&m;
      pb=(pb+4)&m;
      }
    }
  else
    {
    for( ia=0; ia<n; ia++)
      {
      t1=ctimf1[pa  ];
      ib+=4;
      t2=ctimf1[pa+1];      
      t3=ctimf1[pb  ];
      t4=ctimf1[pb+1];   
      x1=t1-t3;
      x2=t4-t2;
      fft1_tmp[4*ia  ]=  t1+t3;
      fft1_tmp[4*ia+1]=-(t2+t4);
      fft1_tmp[ib  ]=fft1tab[ia].cos*x1-fft1tab[ia].sin*x2;
      fft1_tmp[ib+1]=fft1tab[ia].sin*x1+fft1tab[ia].cos*x2;
      t1=ctimf1[pa+2];
      t2=ctimf1[pa+3];      
      t3=ctimf1[pb+2];
      t4=ctimf1[pb+3];   
      x1=t1-t3;
      x2=t4-t2;
      fft1_tmp[4*ia+2]=  t1+t3;
      fft1_tmp[4*ia+3]=-(t2+t4);
      fft1_tmp[ib+2]=fft1tab[ia].cos*x1-fft1tab[ia].sin*x2;
      fft1_tmp[ib+3]=fft1tab[ia].sin*x1+fft1tab[ia].cos*x2;
      pa=(pa+4)&m;
      pb=(pb+4)&m;
      }
    }
  asmbulk_of_dual_dif(fft1_size, fft1_n, fft1_tmp, fft1tab);
  pc=fft1_pa;
  for(ia=0; ia < nn; ia+=2)
    {
    ib=pc+4*fft1_permute[ia];                               
    ic=pc+4*fft1_permute[ia+1];                             
    fft1_float[ib  ]=fft1_tmp[4*ia  ]+fft1_tmp[4*ia+4];
    fft1_float[ic  ]=fft1_tmp[4*ia  ]-fft1_tmp[4*ia+4];
    fft1_float[ib+1]=fft1_tmp[4*ia+1]+fft1_tmp[4*ia+5];
    fft1_float[ic+1]=fft1_tmp[4*ia+1]-fft1_tmp[4*ia+5];
    fft1_float[ib+2]=fft1_tmp[4*ia+2]+fft1_tmp[4*ia+6];
    fft1_float[ic+2]=fft1_tmp[4*ia+2]-fft1_tmp[4*ia+6];
    fft1_float[ib+3]=fft1_tmp[4*ia+3]+fft1_tmp[4*ia+7];
    fft1_float[ic+3]=fft1_tmp[4*ia+3]-fft1_tmp[4*ia+7];
    }
  }  
}
