


#include <vga.h>
#include "globdef.h"
#include "uidef.h"

extern int fh;

void set_mouse(void)
{
vga_setmode(TEXT);
graphics_flag=0;
clearscreen();
printf("svgalib reports your mouse is type %d.\n",vga_getmousetype());
printf(
"Edit /etc/vga/libvga.config if wrong.(man vga_getmousetype for info)\n\n");
gtm:;
printf("Enter mouse speed reduction factor:");
scanf("%d", &ui.mouse_speed);
getchar();
if (ui.mouse_speed < 1 || ui.mouse_speed > 1000)
  {
  printf("Error: Factor out of range\n\n");
  goto gtm;
  }
}

void set_vgamode(void)
{
char s[80];
int *modflag;
int i, grp;
vga_modeinfo *info;
modflag = chk_malloc((GLASTMODE+1) * sizeof(int),1034);
modflag[0]=0;
vga_setmode(TEXT);
graphics_flag=0;
begin:;
clearscreen();
printf("Choose one of the following video modes: \n");
grp=0;
for (i = 1; i <= GLASTMODE; i++)
  {
  if (vga_hasmode(i))
    {
    info = vga_getmodeinfo(i);
    if (info->colors == 256)
      {
      modflag[0]++;
      modflag[i]=1;
      sprintf(s,"%5d: %dx%d       ",i, info->width, info->height);
      s[20]=0;
      printf("%s",s); 
      grp++;
      if(grp >= 3)
        {
        grp=0;
        printf("\n");
        }
      }
    else
      {
      modflag[i]=0;
      }  
    }
  }
if(grp != 0)printf("\n");
if(modflag[0] == 0)
  {
  printf("No 256 color graphics found.\n");
  exit(0);
  }  
gtmode:;
printf("Enter mode number: ");
scanf("%d", &ui.vga_mode);
getchar();
printf("\n");
if (modflag[ui.vga_mode] == 0)
  {
  printf("Error: Mode number out of range\n\n");
  goto gtmode;
  }
info = vga_getmodeinfo(ui.vga_mode);
gtfont:;
printf("Enter font scale (1 to 3): ");
scanf("%d", &ui.font_scale);
getchar();
printf("\n");
if (ui.font_scale < 1 || ui.font_scale > 3)
  {
  printf("Error: Font scale out of range\n\n");
  goto gtfont;
  }
if( ui.font_scale*(fh+LINE_SEP)*(SETUP_LINE+8) > info->height)
  {
  printf("Error: Too few lines on screen.");
  printf("\nUse more pixels or smaller font.\n\n Press enter.");
  getchar();
  goto begin;
  }  
free(modflag);
}
