
#include "globdef.h"
#include "sigdef.h"

// Repeat defines so we may notice mistakes.
#define CW_WORDSEP 255
#define CW_SPACE 254
#define CW_DOT 253
#define CW_DASH 252

int cw_item_len[256-CW_DASH]={4,2,2,4};
int *baseband_handle;
float *baseb_out;
float *baseb;
float *baseb_raw;
float *baseb_raw_orthog;
float *baseb_carrier;
float *baseb_carrier_ampl;
float *baseb_totpwr;
float *baseb_envelope;
float *baseb_upthreshold;
float *baseb_threshold;
float *baseb_fit;
float *baseb_errpwr;
float *baseb_agc_level;
unsigned char *baseb_detect_flag;
short int *baseb_ramp;
float *baseb_tmp;
float *cg_tmpbuf;
int cg_statistics_sum;
int cg_wave_start;
float cg_wave_midpoint;
float cg_wave_fit;
float cg_wave_re;
float cg_wave_im;
float cg_wave_dat;
float cg_wave_err;
float *basblock_maxpower;
float *basblock_avgpower;
char *daout;
float *cg_map;
float *cg_statistics;
float *cwlong_buffer;
short int *cg_traces;
short int *mix2_permute;
COSIN_TABLE *mix2_table;
MORSE_DECODE_DATA *cw;
char *bg_volbuf;
char *bg_behind_carrcur;
float *dash_waveform;
float *dot_waveform;
float *dot_midpoint;
float *space_midpoint;
float *trispace_midpoint;
int cg_yzer[CG_MAXTRACE];
int no_of_dots;
int max_no_of_dots;
int max_no_of_dashes;
int no_of_spaces;
int max_no_of_spaces;
int no_of_trispaces;
int max_no_of_trispaces;
int cw_ptr;
int dash_waveform_established;
int cw_detect_flag;
int max_cwdat;
int no_of_cwdat;

double da_block_counter;
int poleval_pointer;
float baseband_sampling_speed;
int cg_no_of_traces;
int cg_lsep;
char cg_color[CG_MAXTRACE];
int cg_osc_ptr;
int cg_osc_offset;
int cg_osc_offset_inc;
int cg_osc_shift_flag;
int cg_max_trlevel;
float cg_code_unit;
float cg_decay_factor;
int cwlong_store_points;
int cwspeed_store_points;
int cg_collect_points;
int cg_shape_bufno;
int cg_update_interval;
int cg_update_count;
float cw_stoninv;

int baseband_size;
int baseband_mask;
int baseband_neg;
int baseb_pa;
int baseb_pb;
int baseb_pc;
int baseb_pd;
int baseb_pe;
int baseb_pf;
int baseb_px;
float baseb_fx;
int mix2_size;
int mix2_n;
int mix2_point;
float mix2_phase;
int daout_bytes;
int daout_mask;
int daout_size;
int new_baseb_flag;
float da_resample_ratio;
float new_da_resample_ratio;
int daout_pa;
int daout_px;
int daout_block;
int daout_bufmask;
int bfo_xpixel;
int bfo10_xpixel;
int bfo100_xpixel;
float daout_phstep;
float daout_phase;
float daout_gain;
int daout_gain_y;
int bfo_flag;
int da_wts;
int db_wts;
int da_maxempty;
int baseb_channels;
int old_baseb_channels;
float baseb_wts;
float da_wttim;  
float baseb_wttim;
float db_wttim;
float da_wait_time;
int da_empty_flag;
POLCOFF poleval_data[POLEVAL_SIZE];
int bg_expand;
int bg_coherent;
int bg_delay;
int bg_da_channels;
int bg_da_bytes;
int bg_twopol;
float bg_expand_a;
float bg_expand_b;
float bg_amplimit;
float bg_agc_amplimit;
float bg_maxamp;
int bg_amp_indicator_x;
int bg_amp_indicator_y;
int da_ch2_sign;
int bg_carrier_x;
int cg_size;
int dash_pts;
int dot_pts;
float dash_sumsq;
float dot_sumsq;
float cwbit_pts;
float dot_pwrmax;
float refpwr;
int basblock_size;
int basblock_mask;
int basblock_hold_points;
int basblock_pa;
float cg_maxmax;
float cg_maxavg;
float baseband_pwrfac;
float agc_factor;
float agc_sumpow1;
float agc_sumpow2;
float agc_attack_factor1;
float agc_attack_factor2;
float agc_release_factor;
float am_dclevel1;
float am_dclevel2;
float am_dclevel_factor1;
float am_dclevel_factor2;
int s_meter_avgnum;
float s_meter_avg;
